%Usage- a function to calculate the targets position and pose angle at every frame. It calculates the pan-tilt-zoom angles at every frame captured

function [position_x, position_y, my_pan, my_tilt, GT_x, GT_y, GT_pan, GT_tilt]=calculate_position_angels(PATH, skip_factor, x_scale, y_scale)


[az, el, roll,GT_x ,GT_y, GT_z ] = ground_truth(PATH,skip_factor);

track_file= sprintf('%s\\features.txt',PATH);
m = dlmread(track_file,' ') ; 
m = m(1:size(m,1)-1,1:size(m,2));



% Zoom information

[fst_scale , delta_scales  z_val]  = zoom(PATH);
%{
figure;
plot(1:size(fst_scale), fst_scale);
xlabel('Frame number'); ylabel('fst_scale degree');

figure;
plot(1:size(delta_scales), delta_scales);
xlabel('Frame number'); ylabel('Delta scales value');

figure;
plot(1:size(z_val), z_val);
xlabel('Frame number'); ylabel('Zoom value');
axis ([1 length(z_val) 0.8 1.2]);

figure;
plot(1:size(fst_scale), fst_scale-5  , 'k', 1:length(delta_scales), delta_scales, '--g', 'lineWidth',5); set(gca,'FontSize',24, 'FontWeight', 'bold')
xlabel('Frame number'); ylabel('Z position'); legend ('SIOF Z position', 'Measured Z position +++');
%}

% Pan-tilt information
[pan, tilt] = pan_tilt(PATH);

% displacement information

[disp_x, disp_y, midmass_x, midmass_y] = displacement2(PATH);

%%%%%%%%%%%%%%%%%%%%%%%MOTION PARAMETERS
fps=5;
fpc=5;
p_dpp = 0.1;
t_dpp = 0.1;
a_pan = p_dpp*fps;
b_pan = p_dpp*fps/fpc;
a_tilt=-t_dpp*fps;
b_tilt=-t_dpp*fps/fpc;
k_motion = 0.75;
k_position = 0.35;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%all_pan(1) = pan(1);
%all_tilt(1) = tilt(1);

position_x = zeros(size(pan));
position_y = zeros(size(tilt));


len = min(length(pan), length(disp_x));

position_x (1) = k_motion*(a_pan *disp_x(1)) + k_position*((midmass_x(1)-160))-pan(1)*p_dpp;%( midmass_x(1)-160);
position_y (1) = k_motion*(a_tilt*disp_y(1))+ k_position*((midmass_y(1)-120))-tilt(1)*t_dpp;%( midmass_y(1)-120);
    
    
for i= 2:len
    position_x (i)= position_x(i-1)+ k_motion*(a_pan *disp_x(i)) + k_position*((midmass_x(i)-160))-pan(i)*p_dpp;%+(midmass_x(i)-160)/b_pan+disp_x(i-1)/a_pan-10*pan(i);%- pan(i) * p_dpp;%midmass_x(i-1) - 160  +disp_x(i-1) - pan(i) * p_dpp;
    position_y (i)= position_y(i-1)+ k_motion*(a_tilt*disp_y(i))+ k_position*((midmass_y(i)-120))-tilt(i)*t_dpp;%k_position*int8(((midmass_y(i)-120)/b_tilt));%(midmass_y(i)-120)/b_tilt+disp_y(i-1)-10*tilt(i);%position_y (i-1) + disp_y(i)%- tilt(i)* t_dpp;%midmass_y (i-1) - 120  +disp_y(i-1) - tilt(i) * t_dpp;
end

  position_x = (position_x / (320/8.47))/x_scale;%/1.59574;
  position_y = (position_y / (240/6.35))/y_scale;%/1.5748 ;


for i= 2:len
    if position_x (i) < 0.2 & position_x (i) > -0.2 
        break;
    end
end


position_x = position_x (i: length(position_x));
position_y = position_y (i: length(position_y));
position_x = position_x - position_x(1);
position_y = position_y - position_y(1);

min_length = min([length(position_x) length(GT_x)]);

position_x = position_x (1: min_length);
position_y = position_y (1: min_length);

GT_x = -(GT_x (1: min_length) -GT_x(1));
GT_y = GT_y (1: min_length) -GT_y(1);

my_pan= zeros(min_length,1);
my_tilt = zeros(min_length,1);


GT_pan = zeros(min_length,1);
GT_tilt = zeros(min_length,1);

my_pan(1) = atan2(0,1)  * 180/pi;
my_tilt(1) = atan2(0,1) * 180/pi;

GT_pan(1) = 0;
GT_tilt(1)= 0;

for i =2:min_length
    my_pan(i) = pan(i);%int8(atan2(position_x(i)-position_x(i-1),1))* 180/pi;
    my_tilt(i)= tilt(i);%int8(atan2(position_y(i)-position_y(i-1),1))* 180/pi;

   GT_pan(i) = k_motion*int8(pan(i-1) + a_pan *(GT_x(i)-GT_x(i-1)) ) + k_position*int8(b_pan*(GT_x(i)));%-position_x(i);%(atan2(GT_x(i)-GT_x(i-1),1))* 180/pi;
   GT_tilt(i)= k_motion*int8(tilt(i-1)+ a_tilt*(GT_y(i)-GT_y(i-1)) ) + k_position*int8(b_tilt*(GT_y(i)));%-position_y(i);%(atan2(GT_y(i)-GT_y(i-1),1))* 180/pi;

end

%adjusting feature correspondenes
correspondences = zeros (size (m));
F=floor(size(m,1)/2)
for i=0:F-1
    i
   correspondences(i+1,:) = m(2*i+1,:);
   correspondences(F+i+1,:) = m(2*i+2,:);
end 

correspondences

correspondences_NEW = correspondences;
size(pan)

for i= 2:F-1
    for j = 2:size( correspondences,2)
    
    correspondences_NEW (i)=   correspondences(i)+ k_motion*(a_pan *disp_x(i)) + k_position*((midmass_x(i)-160))-pan(i)*p_dpp;%+(midmass_x(i)-160)/b_pan+disp_x(i-1)/a_pan-10*pan(i);%- pan(i) * p_dpp;%midmass_x(i-1) - 160  +disp_x(i-1) - pan(i) * p_dpp;
    correspondences_NEW (i+F)= correspondences(i+F)+ k_motion*(a_tilt*disp_y(i))+ k_position*((midmass_y(i)-120))-tilt(i)*t_dpp;%k_position*int8(((midmass_y(i)-120)/b_tilt));%(midmass_y(i)-120)/b_tilt+disp_y(i-1)-10*tilt(i);%position_y (i-1) + disp_y(i)%- tilt(i)* t_dpp;%midmass_y (i-1) - 120  +disp_y(i-1) - tilt(i) * t_dpp;
    end
end

correspondences_NEW
reconstruct(PATH,correspondences_NEW, skip_factor);

end