/*
 * httpget - execute HTTP GET requests
 *	host is a network address in dotted quad, port is the port number, and path is a full HTTP path
 *	buf is the previously allocated storage buffer of length buflen that will store the full response
 *
 *	on completion *cont will mark the beginning of content in buf
 *		or conversely where the HTTP headers have ended
 *	and *contlen will define the length of *cont as specified by the Content-Length field
 *
 * 	note that host and port are statically stored upon first call and is ignored on subsequent ones
 */

void httpget(char *host, int port, char *path, char buf[], int buflen, char **cont, int *contlen);
