#include "kalman.h"
#include <stdio.h>
#include <stdlib.h>

CvKalman* mykalman;
CvKalman* z_mykalman;
//CvMat *state,*process_noise;


void kalman_init(int nparams, const float* F, CvMat* initstate){

	CvRNG rng = cvRNG(-1);

	mykalman = cvCreateKalman( nparams, nparams, 0 );

	memcpy( mykalman->transition_matrix->data.fl, F, sizeof(F));

	cvSetIdentity(mykalman->transition_matrix, cvRealScalar(1));
	mykalman->transition_matrix->data.fl[2] = 13.0;
	mykalman->transition_matrix->data.fl[7] = 13.0;


	cvSetIdentity( mykalman->measurement_matrix, cvRealScalar(1) );
    cvSetIdentity( mykalman->process_noise_cov, cvRealScalar(5e-1) );		//1e-5
    cvSetIdentity( mykalman->measurement_noise_cov, cvRealScalar(1e-1) );	//1e-1
    cvSetIdentity( mykalman->error_cov_post, cvRealScalar(1));				//1
	cvCopy(initstate, mykalman->state_post, NULL);

	//cvRandArr( &rng, mykalman->state_post, CV_RAND_NORMAL, cvRealScalar(0), cvRealScalar(1) );
}



const CvMat* kalman_predict(){

	cvKalmanPredict( mykalman, 0 );
	return mykalman->state_pre;

}


const CvMat* kalman_correct(CvMat* measurement){

	cvKalmanCorrect( mykalman, measurement );
	return mykalman->state_post;
}


void kalman_deinit(){
	
	cvReleaseKalman(&mykalman);

}



void z_kalman_init(int nparams, const float* F, CvMat* initstate){

	CvRNG rng = cvRNG(-1);

	z_mykalman = cvCreateKalman( nparams, nparams, 0 );

	memcpy( z_mykalman->transition_matrix->data.fl, F, sizeof(F));

	cvSetIdentity(z_mykalman->transition_matrix, cvRealScalar(1));
	z_mykalman->transition_matrix->data.fl[2] = 13.0;
	z_mykalman->transition_matrix->data.fl[7] = 13.0;


	cvSetIdentity( z_mykalman->measurement_matrix, cvRealScalar(1) );
    cvSetIdentity( z_mykalman->process_noise_cov, cvRealScalar(5e-1) );		//1e-5
    cvSetIdentity( z_mykalman->measurement_noise_cov, cvRealScalar(1e-1) );	//1e-1
    cvSetIdentity( z_mykalman->error_cov_post, cvRealScalar(1));				//1
	cvCopy(initstate, z_mykalman->state_post, NULL);

	//cvRandArr( &rng, z_mykalman->state_post, CV_RAND_NORMAL, cvRealScalar(0), cvRealScalar(1) );
}



const CvMat* z_kalman_predict(){

	cvKalmanPredict( z_mykalman, 0 );
	return z_mykalman->state_pre;

}


const CvMat* z_kalman_correct(CvMat* measurement){

	cvKalmanCorrect( z_mykalman, measurement );
	return z_mykalman->state_post;
}


void z_kalman_deinit(){
	
	cvReleaseKalman(&z_mykalman);

}
