#include "error.h"
#include "os.h"
#include "webview.h"
#include "target.h"
#include "kalman.h"
#include <math.h>
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>
#include <stdio.h>
#include <stdlib.h>

#include "defs.h"


////////////////////////from the new opencv sift/match/////////////////
#include "sift.h"
#include "imgfeatures.h"
#include "utils.h"

#include <highgui.h>
#include <stdio.h>
#include "kdtree.h"
#include "xform.h"
#include <cv.h>
#include <cxcore.h>

#include <time.h>
    

#define MAX_CORNERS 500
#define MAX_N 50



IplImage *dispimage, *dispimage2;
IplImage *past, *current, *oflow, *mask, *mask1, *siftimg, * past_siftimg, * sift_output, *img1, *img2;
IplImage *pyrA, *pyrB;
CvRect siftbox;
CvPoint2D32f cornersA[MAX_CORNERS];
CvPoint2D32f cornersB[MAX_CORNERS]; 

//added
CvPoint img1NPoints[MAX_N];
CvPoint img2NPoints[MAX_N]; 

CvPoint2D32f delta[MAX_CORNERS]; 
CvPoint p0, p1, pa, pb;
int corner_count = MAX_CORNERS, cornerSIFT_count= MAX_CORNERS;
int win_size = 10;
char features_found[MAX_CORNERS];
float feature_errors[MAX_CORNERS];
CvMat* state , * z_state;			/* system state */
//const 
int fpc = 5;//13, 20;		/* frames per control */
//const 
double fps = 5.0;//5,30, 20	/* frames per second */
double p_dpp = 1.0/10, t_dpp = 1.0/10, z_dpp = 1.0/10;		/* degrees per pixel (1/9.5 and 0.1)*/
int ctrlx = 0;
int ctrly = 0;
double ctrlz = 0;
double deltaScales = 0;
double firstScale;
double zz ;
float lastx = 0.00;
FILE *features, *PTangles, *Zinfo, *displacement, *PTZerrors;
int frame_number =0;
static char file_name [20];
int shift = 0;
//static int times=0;
CvPoint2D32f salams_disp ;

//FOR SIFTMATCH function
struct feature* feat1, * feat2, *refined_feat2 ;
int n1, n2, m;

/* populate cornersA with a mask using rect* */
int corners(IplImage *img, IplImage *mask, int num_corners);

void flagoutliers();

void prune_features(CvPoint2D32f pointsA[],CvPoint2D32f pointsB[],char 
point_found[],float point_error[],int *corner_count, int threshold);

IplImage* getConvexMask(CvPoint2D32f features[], int count);

//added
IplImage* getConvexMaskSIFT(struct feature* feat, int count);

void update_features();
//added
void update_SIFTfeatures();

void drawcircles();

void drawarrows();

CvPoint2D32f get_middlemass();

CvPoint2D32f get_displacement();

CvPoint2D32f median(CvPoint2D32f* array, int size);

void get_pt_velocity();
void get_z_velocity(); //added

double calcRatio(CvPoint [], CvPoint [],  int counter);

double calcScalesMedian(double points[], int counter);

/* --------------------SIFT Local function prototypes ------------------------ */
void siftfeat(); //// instead of siftfeat main
double siftmatch();//(IplImage* img1, IplImage* img2); //// instead of match main

/******************************** Globals ************************************/
char* img_file_name = "cvImg1.png"; 
char* out_file_name  = "beaver.sift";;
char* out_img_name = NULL;
int display = 1;
int intvls = SIFT_INTVLS;
double sigma = SIFT_SIGMA;
double contr_thr = SIFT_CONTR_THR;
int curv_thr = SIFT_CURV_THR;
int img_dbl = SIFT_IMG_DBL;
int descr_width = SIFT_DESCR_WIDTH;
int descr_hist_bins = SIFT_DESCR_HIST_BINS;

//added
struct feature* featA, *featB;

///////////////////////////from sift match////////////////////////////////////////////
/* the maximum number of keypoint NN candidates to check during BBF search */
#define KDTREE_BBF_MAX_NN_CHKS 300//200

/* threshold on squared ratio of distances between NN and 2nd NN */
#define NN_SQ_DIST_RATIO_THR 0.49

void
processinit()
{	
	int k;
//	CPDIdev m_pdiDev;
//	ePiCommType eType;

	siftbox.x = box.x;
	siftbox.y = box.y;
	siftbox.width = box.width;
	siftbox.height = box.height;
	//struct feature* feat1; //added from sift
	/* to initialize files*/

//	eType = m_pdiDev.DiscoverCnx();

	features = fopen("features.txt","w");
	Zinfo = fopen("Zinfo.txt","w");
	PTangles = fopen("PTangles.txt","w");
	displacement = fopen("disp.txt","w");
	PTZerrors = fopen("PTZerrors.txt", "w");
	
	GetLiveImage(); 
	past = cvCreateImage(cvGetSize(image),image->depth,1);
	current = cvCreateImage(cvGetSize(image),image->depth,1);
	oflow = cvCreateImage(cvGetSize(image),image->depth,1);
	siftimg = cvCreateImage(cvGetSize(image),image->depth,1);//added
	past_siftimg = cvCreateImage(cvGetSize(image),image->depth,1);//added

	img1 = cvCreateImage(cvGetSize(image),image->depth,1);//added
	img2 = cvCreateImage(cvGetSize(image),image->depth,1);//added

	sift_output = cvCreateImage(cvGetSize(image),image->depth,1);//added
	
	mask = cvCreateImage(cvGetSize(image),image->depth,1);

	////added 
	mask1 = cvCreateImage(cvGetSize(image),image->depth,1);


	/* convert image to grayscale, store in current and smooth */
	cvCvtColor(image,current,CV_BGR2GRAY);
	cvSmooth(current,current,CV_BLUR,3,3,0,0);
	/* for performance */
	{
		CvSize sz = cvSize(past->width+8,current->height/3);
		pyrA = cvCreateImage(sz,image->depth,1);
		pyrB = cvCreateImage(sz,image->depth,1);
	}
	/* initialize mask */
	cvSetZero(mask);
	cvSetImageROI(mask,box); 
	cvNot(mask,mask);
	cvResetImageROI(mask);

	cvSetZero(mask1);
	cvSetImageROI(mask1,box); 
	cvNot(mask1,mask1);
	cvResetImageROI(mask1);

	/* find corners in current image with mask defined by user drawn box */
	corner_count = corners(current, mask, corner_count);
	
	/* initially set past and current feature locations equall so displacement = 0 */
	for (k = 0; k<corner_count; k++){
			cornersB[k] = cornersA[k];
			delta[k].x = 0.0;
			delta[k].y = 0.0;
	}


	/* kalman filter initialization*/
	{
		int dt = fpc;
		/* define kalman filter transition matrix */
		const float F[] = {1, 0, 13.0, 0,
						   0, 1, 0, 13.0,
					       0, 0, 1, 0,
					       0, 0, 0, 1};

				/* define kalman filter transition matrix */
		const float z_F[] = {1, 0, 13.0, 0,
						   0, 1, 0, 13.0,
					       0, 0, 1, 0,
					       0, 0, 0, 1};
		/* define initial state */
		CvPoint2D32f center;
		center = get_middlemass();				/* center coordinates (u,v) of selected features */
		state = cvCreateMat( 4, 1, CV_32FC1 );  /* [u, v, u_dot, v_dot]' */
		state->data.fl[0] = center.x;
		state->data.fl[1] = center.y;
		state->data.fl[2] = 0.0;
		state->data.fl[3] = 0.0;
		/* initialize kalman filter */
		kalman_init(4,F,state);
		kalman_predict();
	
		/* define initial state */

		z_state = cvCreateMat( 2, 1, CV_32FC1 );  /* [u, v, u_dot, v_dot]' */
		z_state->data.fl[0] = 0;

		/* initialize kalman filter */
		z_kalman_init(2,z_F,z_state);
		z_kalman_predict();
	}
	siftbox = cvRect(box.x,box.y,box.width,box.height);
}

void
processdeinit()
{
	cvReleaseImage(&past);
	cvReleaseImage(&current);
	cvReleaseImage(&oflow);
	cvReleaseImage(&mask);
//added
	cvReleaseImage(&mask1);
	cvReleaseImage(&siftimg);
	cvReleaseImage(&img1);
	cvReleaseImage(&img2);
	cvReleaseImage(&past_siftimg);
	cvReleaseImage(&sift_output);
	
	cvReleaseImage(&pyrA);
	cvReleaseImage(&pyrB);
	kalman_deinit();
	z_kalman_deinit();
	
	fclose(features);
	fclose(PTangles);
	fclose(Zinfo);
	fclose(displacement);
	fclose(PTZerrors);
}

void
process()
{
	CvPoint2D32f midmass;
	CvPoint2D32f disp;
	int thresh = 300;
	double scalesMid;

	int i,j=0;
	//for measuring cpu time using time.h
	clock_t start, end;
    double cpu_time_used;

	int kalman_error=0, delay_error=0;	//were local variables to kalman predict block
	int z_kalman_error=0, z_delay_error=0;

	cvReleaseImage(&mask); 
	//added
	cvReleaseImage(&mask1); 
	cvReleaseImage(&oflow);
	cvReleaseImage(&past);

	cvReleaseImage(&past_siftimg);		//////// should be released each time !!!

	cvReleaseImage(&sift_output); 

	past = current;
	
	past_siftimg = siftimg; //cvCreateImage(cvGetSize(image),image->depth,1);//added
	
	oflow = cvCreateImage(cvGetSize(image),image->depth,1);
	
	current = cvCreateImage(cvGetSize(image),image->depth,1);
	
	siftimg = cvCreateImage(cvGetSize(image),image->depth,1);

	sift_output = cvCreateImage(cvGetSize(image),image->depth,1);

	cvCvtColor(image,current,CV_BGR2GRAY);

	cvCopy(current,oflow,NULL);
	cvCopy(current,sift_output,NULL);

	cvSmooth(current,current,CV_BLUR,3,3,0,0);
	
	
//////// SIFT matching here
	
	cvCopy(current,siftimg,NULL);//added
	
     /* Do the work. */
     
		scalesMid = siftmatch();
//	}
	 start = clock();
	/* Track feature points using optical flow */
	cvCalcOpticalFlowPyrLK(
		past,
		current,
		pyrA,
		pyrB,
		cornersA,
		cornersB,
		corner_count,
		cvSize( win_size,win_size ),
		5,
		features_found,
		feature_errors,
		cvTermCriteria( CV_TERMCRIT_ITER | CV_TERMCRIT_EPS, 20, .3 ),
		CV_LKFLOW_INITIAL_GUESSES
	);

	/* Eliminate any features with error above threshold (300) */
	flagoutliers();
	prune_features(cornersA,cornersB,features_found,feature_errors,&corner_count,thresh);

	/* Draw oflow arrows onto grayscale image and update feature matrices */
	//drawarrows();
	update_features();

	end = clock();
    cpu_time_used = ((double) (end - start)) / CLOCKS_PER_SEC;
//	fprintf(stderr,"CPU time used is : %f\n", cpu_time_used);

	drawcircles();

	/* Find middle mass of corner points*/
	midmass = get_middlemass();

	errorupdate(midmass.x,midmass.y);
	
	/* Find median displacement vector*/
	disp = median(delta, corner_count);

	/* Find convex hull around tracked points */
	mask = getConvexMask(cornersA,corner_count);

	/* Shade this region on the output image  */
	cvAddS(oflow, cvScalar(-65,0,0,0), oflow, mask);


	/* Send Camera Controls */
	{
		static int c = 0;j = c;
		if (++c%fpc == 0) { /* issue control every (fpc) frames */

			CvMat* temp;
			CvMat* z_temp;
			
			kalman_error = (int)(p_dpp*(midmass.x - state->data.fl[0]));
			delay_error  = (int)(p_dpp*(midmass.x - lastx));
			lastx = midmass.x;

			errorupdate2(kalman_error, delay_error);

			/* update parameters in system state (measurement phase) */
			state->data.fl[0] = midmass.x;
			state->data.fl[1] = midmass.y;
			state->data.fl[2] = disp.x;
			state->data.fl[3] = disp.y;

			/* correct state estimate */

			temp = kalman_correct(state);

			/* predict next state (prediction phase) */
			cvCopy(kalman_predict(), state, NULL); 

			get_pt_velocity();

			//ZOOM Predict
			z_kalman_error = (int)((firstScale -  deltaScales ));
			z_delay_error  = (int)(p_dpp*(midmass.x - lastx));

			errorupdate3(z_kalman_error, z_delay_error);

		/* correct state estimate */
			
			z_temp = z_kalman_correct(z_state);
		
			/* predict next state (prediction phase) */
			cvCopy(z_kalman_predict(), z_state, NULL); 

				ctrlz = fabs((firstScale + deltaScales ) / firstScale) ;
			//ctrlx=0;ctrly=0;ctrlz=1;
			OperateCamera(ctrlx,ctrly, ctrlz);//,1); /* in degrees per second */
		//	}
		}
	}

	/* Clean up and assign display images */
	cvReleaseImage(&pyrA);
	cvReleaseImage(&pyrB);
	dispimage = image;
	dispimage2 = oflow;
	
disp1 = get_displacement();


}

fprintf(features,"\n");
for (i = 0; i<corner_count; i++){
fprintf(features,"%f ", cornersA[i].y);
}

fprintf(features,"\n");
/*
if(frame_number == 2|| frame_number%==0){
sprintf(file_name,"img%d.png",frame_number);
cvSaveImage( file_name, image);
}
*/
frame_number++;
}


double calculate_distance(double x1, double y1, double x2, double y2)
{  
    double diffx = x1 - x2;
    double diffy = y1 - y2;
    double diffx_sqr = square (diffx);
    double diffy_sqr = square (diffy);
    double distance = sqrt (diffx_sqr + diffy_sqr);
	return distance;
}

void get_pt_velocity()
{
	double pan,tilt,zoom; 
	/* dampening coefficients, to compensate for lag (0.75 and 0.35) */
	double k_motion = 0.75, k_position = 0.35;	
	/* coefficient to convert pixels/frame to degrees/s */
	double a_pan = p_dpp*fps;
	double a_tilt=-t_dpp*fps;
	double a_zoom= z_dpp*fps;
	/* coefficient to convert pixels/control to degrees/s */
	double b_pan = p_dpp*fps/fpc;
	double b_tilt=-t_dpp*fps/fpc;
	double b_zoom= z_dpp*fps/fpc;

	pan = k_motion*(ctrlx + (int)(a_pan*state->data.fl[2])) 
		+ k_position*(int)(b_pan*(state->data.fl[0]-160)) ;

	tilt = k_motion*(ctrly + (int)(a_tilt*state->data.fl[3]))
		 + k_position*(int)(b_tilt*(state->data.fl[1]-120));
 
//	zoom = k_motion*(ctrlz + (int)(a_zoom*state->data.fl[3]))
//		 + k_position*(int)(b_zoom*(state->data.fl[1]-120));

	ctrlx = (int)pan;
	ctrly = (int)tilt;
//	ctrlz = (int)zoom;
}



CvPoint2D32f
get_middlemass()
{
	CvPoint2D32f mm = cvPoint2D32f(0.00,0.00);
	int i;
	for (i=0;i<corner_count; i++) {
		mm.x+=cornersA[i].x;
		mm.y+=cornersA[i].y;
	}
	mm.x/=corner_count;
	mm.y/=corner_count;
	return mm;
}

CvPoint2D32f
get_displacement()
{
	CvPoint2D32f ave_disp = cvPoint2D32f(0.00,0.00);
	int i;
	for (i=0;i<corner_count; i++) {
		ave_disp.x+=delta[i].x;
		ave_disp.y+=delta[i].y;
	}
	ave_disp.x/=corner_count;
	ave_disp.y/=corner_count;
	return ave_disp;
}

CvPoint2D32f /* returns the x and y medians of a CvPoint array */
median(CvPoint2D32f* array,int size) 
{
	int i,j;
	CvPoint2D32f points[MAX_CORNERS];
	float minx,miny;
	for (i = 0; i<size; i++){
			points[i] = array[i];
	}
	/* arrange points in ascending order up to n = N/2*/
	for (j=0;j<size/2;j++){
		minx = 10000; /*set minx to high value*/
		miny = 10000; /*set miny to high value*/
		for (i=j;i<size;i++){
			if(points[i].x<minx){
				minx = points[i].x;
				points[i].x = points[j].x;
				points[j].x = minx;
			}
			if(points[i].y<miny){
				miny = points[i].y;
				points[i].y = points[j].y;
				points[j].y = miny;
			}
		}
	}
	
	return points[size/2];
}

void
drawarrows()
{
	CvPoint p0, p1, pa, pb;
	double r, theta, k = 0.5;
	int i;

	for(i=0; i<corner_count; i++ ) {

			//distance line
			p0 = cvPoint(
				cvRound( cornersA[i].x ),
				cvRound( cornersA[i].y )
			);
			p1 = cvPoint(
				cvRound( cornersB[i].x ),
				cvRound( cornersB[i].y )
			);
			//arrow lines
			r = (1-k)*sqrt(pow((cornersB[i].x - cornersA[i].x),2)+pow((cornersB[i].y - cornersA[i].y),2));
			theta = atan2(-(cornersB[i].x - cornersA[i].x),(cornersB[i].y - cornersA[i].y));

			pa = cvPoint(
				cvRound( cornersA[i].x + (cornersB[i].x - cornersA[i].x)*k + r*cos(theta)),
				cvRound( cornersA[i].y + (cornersB[i].y - cornersA[i].y)*k + r*sin(theta))
			);
			pb = cvPoint(
				cvRound( cornersA[i].x + (cornersB[i].x - cornersA[i].x)*k + r*cos(theta+3.14)),
				cvRound( cornersA[i].y + (cornersB[i].y - cornersA[i].y)*k + r*sin(theta+3.14))
			);

			//draw distance line
			cvLine( oflow, p0, p1, CV_RGB(255,255,255),1,CV_AA,0);
			//draw arrow lines
			cvLine( oflow, p1, pa, CV_RGB(255,255,255),1,CV_AA,0);
			cvLine( oflow, p1, pb, CV_RGB(255,255,255),1,CV_AA,0);

	}
}

void
drawcircles()
{
	CvPoint p0;
	int i;
	for(i=0; i<corner_count; i++ ) {
			//store feature location
			p0 = cvPoint(
				cvRound( cornersA[i].x ),
				cvRound( cornersA[i].y )
			);
			//draw circle to show position of feature
			cvCircle(oflow,p0,3,CV_RGB(255,255,255),1,8,0);
			//cvLine( oflow, p0, p1, CV_RGB(255,255,255),1,CV_AA,0);
	}
}

void
update_features() //update point locations
{
	CvPoint2D32f deltapast; //holds previous frame's displacement vectors
	int i;
	for(i=0; i<corner_count; i++ ) {
		//displacement vectors
		deltapast = delta[i];
		delta[i].x = cornersB[i].x -cornersA[i].x;	
		delta[i].y = cornersB[i].y -cornersA[i].y;
		//feature points in current frame
		cornersA[i].x = cornersB[i].x;				
		cornersA[i].y = cornersB[i].y;
		//predicted points for next frame = current postion+velocity+(1/2)acceleration
		cornersB[i].x += delta[i].x+(delta[i].x-deltapast.x)/2.0f;	
		cornersB[i].y += delta[i].y+(delta[i].y-deltapast.y)/2.0f;
	}
}


void
flagoutliers()
{
	int i;
	for(i=0; i<corner_count; i++ ) {

	}
}




int
corners(IplImage *img, IplImage *mask, int num_corners)
{
	IplImage *eig, *tmp;

	eig = cvCreateImage(cvGetSize(img),IPL_DEPTH_32F,1);
	tmp = cvCreateImage(cvGetSize(img),IPL_DEPTH_32F,1);

	cvGoodFeaturesToTrack(
		img,
		eig,
		tmp,
		cornersA,
		&num_corners,
		0.025, //0.01
		5.0, 
		mask,
		3,
		0,
		0.4
	);

	if (num_corners == MAX_CORNERS) {
		fprintf(stderr,"process: NCORNERS too small\n");
		exit(1);
	}

	cvFindCornerSubPix(
		img,
		cornersA,
		num_corners,
		cvSize(win_size,win_size),
		cvSize(-1,-1),
		cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03)
	);

	cvReleaseImage(&eig);
	cvReleaseImage(&tmp);
	return num_corners;
}

void
prune_features(CvPoint2D32f pointsA[],CvPoint2D32f pointsB[],char 
point_found[],float point_error[],int *num_corners, int threshold)
{
	int count = -1, i = 0;
	for (i=0; i<*num_corners; i++) {
		if( !point_found[i] || point_error[i]>threshold ) {
				continue;
		}
		count++;
		pointsA[count] = pointsA[i];
		pointsB[count] = pointsB[i];
		delta[count] = delta[i];
	}
	if (count>-1)
		*num_corners = count+1;
}

IplImage*
getConvexMask(CvPoint2D32f* points, int count)
{
	IplImage* mask = cvCreateImage( cvGetSize(image), image->depth, 1);
	int i;
	int hullcount;

	int* hull = (int*)malloc( count * sizeof(hull[0]));
	CvPoint* features = (CvPoint*)malloc( count * sizeof(features[0])); 
	CvPoint* hullpoints = (CvPoint*)malloc( count * sizeof(hullpoints[0])); // exterior points
	CvMat pointMat = cvMat( 1, count, CV_32SC2, features); 
    CvMat hullMat = cvMat( 1, count, CV_32SC1, hull );
	//copy rounded input points into array
	for (i = 0; i<count; i++){ 
			features[i].x = cvRound(points[i].x); 
			features[i].y = cvRound(points[i].y);
	}
		
	cvZero(mask);
    cvConvexHull2(&pointMat, &hullMat, CV_CLOCKWISE, 0 );
    hullcount = hullMat.cols;
	cvZero(mask);

	for( i = 0; i < hullcount; i++ )
    {
				hullpoints[i].x = cvRound(features[hull[i]].x); //points, features
				hullpoints[i].y = cvRound(features[hull[i]].y); //points, features
	}

	cvFillConvexPoly( mask,hullpoints, hullcount, CV_RGB( 255, 255, 255 ),0,0);

//added
	siftbox = cvBoundingRect(&pointMat,0);


	free( features );
	free( hullpoints );
    free( hull );
	return mask;
}



///added 10-28-09
IplImage*
getConvexMaskSIFT(struct feature* feat, int count)
{
	IplImage* mask1 = cvCreateImage( cvGetSize(image), image->depth, 1);
	int i;
	int hullcount;

	int* hull = (int*)malloc( count * sizeof(hull[0]));
	CvPoint* features = (CvPoint*)malloc( count * sizeof(features[0])); 
	CvPoint* hullpoints = (CvPoint*)malloc( count * sizeof(hullpoints[0])); // exterior points

	CvMat pointMat = cvMat( 1, count, CV_32SC2, features); 
    CvMat hullMat = cvMat( 1, count, CV_32SC1, hull );
	//copy rounded input points into array
	for (i = 0; i<count; i++){ 
			features[i].x = cvRound(feat[i].x); 
			features[i].y = cvRound(feat[i].y);
	}
		
	cvZero(mask1);
    cvConvexHull2(&pointMat, &hullMat, CV_CLOCKWISE, 0 );
    hullcount = hullMat.cols;
	cvZero(mask1);

	for( i = 0; i < hullcount; i++ )
    {
				hullpoints[i].x = cvRound(features[hull[i]].x); //points, features
				hullpoints[i].y = cvRound(features[hull[i]].y); //points, features
	}
	
	cvFillConvexPoly( mask1,hullpoints, hullcount, CV_RGB( 255, 255, 255 ),0,0);

	free( features );
	free( hullpoints );
    free( hull );
	return mask1;
}



///////////////SIFT functions ///////////////////
void siftfeat()
{
	IplImage* img;
	struct feature* features;
	int n = 0;

	fprintf( stderr, "Finding SIFT features...\n" );
	img = cvLoadImage( img_file_name, 1 );
	if( ! img )
	{
		fprintf( stderr, "unable to load image from %s", img_file_name );
		exit( 1 );
	}
	n = _sift_features( img, &features, intvls, sigma, contr_thr, curv_thr,
						img_dbl, descr_width, descr_hist_bins );
	fprintf( stderr, "Found %d features.\n", n );

	if( display )
	{
		draw_features( img, features, n );
		cvNamedWindow( img_file_name, 1 );
		cvShowImage( img_file_name, img );
		cvWaitKey( 0 );
	}

	if( out_file_name != NULL )
		export_features( out_file_name, features, n );

	if( out_img_name != NULL )
		cvSaveImage( out_img_name, img );
	
}
double siftmatch()//(IplImage* img1, IplImage* img2)
{
	static int first_time = 0;
	int counter = 0;
	double scales [MAX_N];
	double r = 0 , r1 =0, r2 = 0;
	struct feature* feat;//,  *refined_feat2;//, *actual_feat,;
	struct feature** nbrs;
	struct kd_node* kd_root;
	CvPoint pt1, pt2;
	double d0, d1;
	//int n1, n2,;  //Global	
	int k, i, j;//, m = 0;
	int *matched_points_indeces;
	
	if (first_time == 0){
		cvCopy(past_siftimg,img1,NULL);
		cvSetImageROI(img1, siftbox);
		if( ! img1 )
			fatal_error( "unable to load image 1 ");//, img1_file );
			n1 = sift_features( img1, &feat1 );
			//fprintf( stderr, "n1 is %d\n", n1 );
	}
	else {//copy feature points from feat2 to feat1
		n1=n2;
		feat1 = feat2;
	}

	cvCopy(siftimg,img2,NULL);
	cvSetImageROI(img2, siftbox);
	if( ! img2 )
		fatal_error( "unable to load image from %s");//, img2_file );
	n2 = sift_features( img2, &feat2 );
	matched_points_indeces = (int *) calloc(n2, sizeof(int));//by salam

	kd_root = kdtree_build( feat2, n2 );
	for( i = 0; i < n1; i++ ){
		feat = feat1 + i;
		k = kdtree_bbf_knn( kd_root, feat, 2, &nbrs, KDTREE_BBF_MAX_NN_CHKS );
		if( k == 2 ){
			d0 = descr_dist_sq( feat, nbrs[0] );
			d1 = descr_dist_sq( feat, nbrs[1] );
//			fprintf( stderr, "d0 is %d, d1 is%d\n", d0 , d1 );
			if( d0 < d1 * NN_SQ_DIST_RATIO_THR ){
				pt1 = cvPoint( cvRound( feat->x ), cvRound( feat->y ) );
				pt2 = cvPoint( cvRound( nbrs[0]->x ), cvRound( nbrs[0]->y ) );
				if (counter <MAX_N ){
					img1NPoints[counter] = pt1;
					img2NPoints[counter] = pt2;
					//fprintf(stderr,"\n static var %d", just_2times);
					scales[counter] = nbrs[0]->scl / feat->scl;
					//fprintf(stderr,"\nscale %f and %f", feat->scl, nbrs[0]->scl);
					r1 +=  feat->scl;
					r2 += nbrs[0]->scl;
					counter++;
				}
				pt2.y += img2->height;
	//			cvLine( stacked, pt1, pt2, CV_RGB(255,0,255), 1, 8, 0 );
				feat1[i].fwd_match = nbrs[0];
				matched_points_indeces[m]=i;
				m++;
			}
		}
		free( nbrs );
	}
	//fprintf( stderr, "Found %d total matches\n", m );
	cvResetImageROI(img1);
	cvResetImageROI(img2);
	refined_feat2 = calloc( m, sizeof(struct feature) );
	if( !n2 || first_time==0)
		fprintf(stderr,"no features found\n");
	else{
		cvNamedWindow( "SIFT", 1 );
		for (i = 0 ; i< m ; i++){
			refined_feat2[i].x = feat2[matched_points_indeces[i]].x+ siftbox.x;
			refined_feat2[i].y = feat2[matched_points_indeces[i]].y+ siftbox.y;
		}
		draw_features( sift_output, refined_feat2, m );			
		mask1 = getConvexMaskSIFT(refined_feat2,m);
		cvAddS(sift_output,cvScalar(-65,0,0,0), sift_output, mask1);
		cvShowImage( "SIFT", sift_output);
	}
	if (counter >=2){
		r1 = r1/counter;
		r2 = r2/counter;
		if (fabs(r2 - r1) > 0.02)
			deltaScales += (r2 - r1);
	//	fprintf(stderr,"\ndeltaScales %f", deltaScales);
		if (first_time%fpc == 0){
		   firstScale = r1;
		}
		first_time ++;
	}
	m=0;
	return deltaScales;
}

double calcScalesMedian(double points[], int counter){

	int j, i; double min;
	for (j=0;j<counter/2;j++){
		min = 10000; /*set minx to high value*/
		for (i=j;i<counter;i++){
			if(points[i] < min){
				min = points[i];
				points[i] = points[j];
				points[j] = min;
			}
		}
	}
	
	return points[counter/2];
}