#include "target.h"

#include <highgui.h>

CvRect box;
int drawing_box;

void
targetreset()
{
	box = cvRect(-1,-1,0,0);
	drawing_box = 0;
}

int
targetselected()
{
	return drawing_box == -1;
}

void
target_mouse_callback(int event, int x, int y, int flags, void *param)
{
	switch (event)
	{
	case CV_EVENT_MOUSEMOVE:
		if (drawing_box) {
			box.width = x - box.x;
			box.height = y - box.y;
		}
		break;

	case CV_EVENT_LBUTTONDOWN:
		drawing_box = 1;
		box = cvRect(x,y,0,0);
		break;

	case CV_EVENT_LBUTTONUP:
		if (box.width < 0) {
			box.x += box.width;
			box.width *= -1;
		}
		if (box.height < 0) {
			box.y += box.height;
			box.height *= -1;
		}
		drawing_box = -1; /* indicate box has been drawn */
		break;
	}
}
